#define R (4)

/* prototipos de funciones en este fichero, slo es til llamar a la primera, las dems son auxiliares*/
void mod_a_num(unsigned int *vecmod, unsigned long *vecnum);

void init_ctes(void);
void calc_cctesl(void);
void calc_mctesl(void);
long ext_euclid(unsigned long u, unsigned long v);
void calc_vcomp(unsigned int *u, unsigned int *v);
long modulo_esp(long a, unsigned int b);
/* funciones auxiliares implementadas en ensamblador en aritaux.asm */
extern void prod64(unsigned long *a64, unsigned long *b32, unsigned long *r64);
extern void sum64(unsigned long *a64, unsigned long *b64, unsigned long *r64);


/* variable global externa (definida en main.c) con las constantes sin factores comunes m_i */
extern unsigned int m[R];

/* var. auxiliar con el mismo significado que las m_i */
unsigned long ml[R] = {0L, 0L, 0L,0L};

/* ctes auxiliares */
unsigned long mctesl[R][2] = {{0,0}, {0,0}, {0,0}, {0,0}} ;
long cctesl[R][R];


/* inicializa ctes necesarias para el clculo posterior */
void init_ctes(void){
	static int init_flag=0;
	int i;

	if (!init_flag){
		init_flag = 1;
		for(i=0;i<R;i++){
			ml[i]=(long)m[i];
		}
		calc_cctesl();
		calc_mctesl();
	}
}

/* Calcula las ctes cij */
void calc_cctesl(void){
	int i, j;

	for (i=0;i<R;i++){
		for (j=i+1;j<R;j++){
			cctesl[i][j] = ext_euclid(ml[i], ml[j]);
		}
	}
}

/* Calcula las R ctes M de 64 bits */
void calc_mctesl(void){
	int i;

	mctesl[0][0] = 1;
	mctesl[0][1] = 0;
	for (i=1;i<R;i++){
		prod64(&(mctesl[i-1][0]), &ml[i-1], &(mctesl[i][0]));
	}
}

long ext_euclid(unsigned long u, unsigned long v){
	long u1, u3, v1, v3, t1, t3, q;

	u1 = 1L;
	u3 = u;
	v1 = 0L;
	v3 = v;
	while (v3 != 0L)
	{
		  q = u3/v3;
		  t1 = u1 - v1*q;
		  t3 = u3 - v3*q;
		  u1 = v1;
		  u3 = v3;
		  v1 = t1;
		  v3 = t3;
	}
	return u1;
}

/* convierte el num en repr. modular a repr. en raiz mixta */
void calc_vcomp(unsigned int *u, unsigned int *v){
	long total;
	int i, j;

	for (i=0;i<R;i++){
		total = (unsigned long) u[i];
		for (j=0;j<i;j++){
			total = modulo_esp(modulo_esp((total - (long) v[j]), m[i]) * cctesl[j][i], m[i]);
		}
		v[i] = total;
	}
}

long modulo_esp(long a, unsigned int b){
	long aux1 = (long)b;
	long co;

	if (a < 0) {
		co = a / aux1;
		if ((a-(co*aux1)) == 0) {
			return 0;
		} else {
			return (a-((co-1) * b));
		}
	} else {
		return ((unsigned long) a % (unsigned long) b);
	}
}

void mod_a_num(unsigned int *vecmod, unsigned long *vecnum){
	int i;
	unsigned long temp[2], tmp;
	unsigned int v[R];

	init_ctes();
	calc_vcomp(vecmod, v);
	vecnum[0] = 0L;
	vecnum[1] = 0L;
	for (i=0;i<R;i++){
		tmp = (unsigned long)v[i];
		prod64(&mctesl[i][0], &tmp, temp);
		sum64(vecnum, temp, vecnum);
	}
}